/***
 * Excerpted from "Stripes: and Java Web Development is Fun Again",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fdstr for more book information.
***/


package stripesbook.ext;



import java.util.Arrays;
import java.util.List;
import net.sourceforge.stripes.action.ActionBean;
import net.sourceforge.stripes.action.RedirectResolution;
import net.sourceforge.stripes.action.Resolution;
import net.sourceforge.stripes.controller.ExecutionContext;
import net.sourceforge.stripes.controller.Interceptor;
import net.sourceforge.stripes.controller.Intercepts;
import net.sourceforge.stripes.controller.LifecycleStage;
import stripesbook.action.BaseActionBean;
import stripesbook.action.LoginActionBean;
import stripesbook.action.MockDataLoaderActionBean;
import stripesbook.action.RegisterActionBean;



@Intercepts(LifecycleStage.ActionBeanResolution)
public class LoginInterceptor implements Interceptor {
    @SuppressWarnings("unchecked")
    private static final List<Class<? extends BaseActionBean>> ALLOW =
        Arrays.asList(

    
            MockDataLoaderActionBean.class,
    

            LoginActionBean.class,
            RegisterActionBean.class
        );
    public Resolution intercept(ExecutionContext execContext)
        throws Exception
    {
        Resolution resolution = execContext.proceed();

        MyActionBeanContext ctx =
            (MyActionBeanContext) execContext.getActionBeanContext();

        BaseActionBean actionBean = (BaseActionBean)
            execContext.getActionBean();

        Class<? extends ActionBean> cls = actionBean.getClass();

        if (ctx.getUser() == null && !ALLOW.contains(cls)) {
 


            resolution = new RedirectResolution(LoginActionBean.class);
            if (ctx.getRequest().getMethod().equalsIgnoreCase("GET")) {
                ((RedirectResolution) resolution)
                    .addParameter("loginUrl", actionBean.getLastUrl());
            }

        }                
        return resolution;
    }
}


